/*******************************
 * 
 * 骑享OTA更新测试
 * 
 * ****************************/
#include "bsp.h"
#include "bsp_custom.h"
#include "osasys.h"
#include "ostask.h"
#include "queue.h"
#include "ps_event_callback.h"
#include "app.h"
#include "cmisim.h"
#include "cmimm.h"
#include "cmips.h"
#include "sockets.h"
#include "psifevent.h"
#include "ps_lib_api.h"
#include "lwip/netdb.h"
#include <cis_def.h>
#include "debug_log.h"
#include "slpman_ec616.h"
#include "plat_config.h"


//Main Area
#define PROC_MAIN_TASK_STACK_SIZE           (1024)
uint8_t deepslpTimerID          = DEEPSLP_TIMER_ID7;
uint8_t MainSlpHandler          = 0xff;
static StaticTask_t             gProcess_Main_Task_t;
static UINT8                  gProcess_Main_TaskStack[PROC_MAIN_TASK_STACK_SIZE];
typedef enum
{
    PROCESS_STATE_IDLE = 0,
    PROCESS_STATE_WORK,
    PROCESS_STATE_SLEEP
}process_Main;
static process_Main 		    gProcess_Main_Task = PROCESS_STATE_IDLE;
#define PROC_MAIN_STATE_SWITCH(a)  (gProcess_Main_Task = a)

//tcp area
#define PROC_TCP_TASK_STACK_SIZE           (1024)
static StaticTask_t             gProcess_Tcp_Task_t;
static UINT8                  gProcess_Tcp_TaskStack[PROC_TCP_TASK_STACK_SIZE];
static volatile UINT32          Event;
static UINT8                    gImsi[16] = {0};
static INT32                    sockfd = -1;
static UINT32                   gCellID = 0;
int TcpconnectID = -1;
volatile uint8_t Tcp_statuts = 0;
typedef enum
{
    PROCESS_TCP_STATE_IDLE = 0,
    PROCESS_TCP_STATE_LINK,
    PROCESS_TCP_STATE_WORK,
    PROCESS_TCP_STATE_SLEEP
}process_TCP;
static process_TCP 		    gProcess_Tcp_Task = PROCESS_TCP_STATE_IDLE;
#define PROC_TCP_STATE_SWITCH(a)  (gProcess_Tcp_Task = a)
volatile bool Tcp_Sleep_Flag = false;

//睡眠进出函数
static void appBeforeHib(void *pdata, slpManLpState state)
{
    uint32_t *p_param = (uint32_t *)pdata;

    #ifdef USING_PRINTF
        printf("Before Hibernate:%d \n",state);
    #endif
	slpManAONIOLatchEn(AonIOLatch_Enable);

}

static void appAfterHib(void *pdata, slpManLpState state)
{
    #ifdef USING_PRINTF
        printf("Try Hibernate Failed:%d \n",state);
    #endif
}

static void appBeforeSlp1(void *pdata, slpManLpState state)
{
    #ifdef USING_PRINTF
        printf("Before Sleep1:%d \n",state);
    #endif
	slpManAONIOLatchEn(AonIOLatch_Enable);
}

static void appAfterSlp1(void *pdata, slpManLpState state)
{
    #ifdef USING_PRINTF
        printf("After Sleep1:%d \n",state);
    #endif
}


static void appBeforeSlp2(void *pdata, slpManLpState state)
{
    #ifdef USING_PRINTF
        printf("before sleep2:%d \n",state);
    #endif
	slpManAONIOLatchEn(AonIOLatch_Enable);
}

static void appAfterSlp2(void *pdata, slpManLpState state)
{
    #ifdef USING_PRINTF
        printf("sleep2 failed:%d \n",state);
    #endif
}
// 主任务线程
static void Main_Task(void* arg)
{
    UINT16 Can_index = 0;
    UINT16 Uart_index = 0;
    UINT16 Tcp_index  = 0;
    uint32_t sleep_index = 0;
    uint32_t sleep_time_flag;
    int32_t inParam = 0xAABBCCDD;
    uint32_t Chrgend_Work_time = 1800;
    uint32_t Wakeup_Work_time = 120;
    uint32_t Sleep_Time = 120;
    //上述参数应写入文件里
    slpManWakeSrc_e Wakeup_source;
    PROC_MAIN_STATE_SWITCH(PROCESS_STATE_IDLE);
    NetSocDisplay(LED_SOC_0,LED_TURN_OFF);
    NetSocDisplay(LED_SOC_1,LED_TURN_OFF);
    NetSocDisplay(LED_SOC_2,LED_TURN_OFF);
    NetSocDisplay(LED_SOC_3,LED_TURN_OFF);
    FaultDisplay(LED_TURN_OFF);
    NVIC_EnableIRQ(PadWakeup1_IRQn);

    slpManSetPmuSleepMode(true,SLP_HIB_STATE,false);
    slpManApplyPlatVoteHandle("MainSlp",&MainSlpHandler);
    slpManPlatVoteDisableSleep(MainSlpHandler, SLP_SLP2_STATE); 
    slpManRegisterUsrdefinedBackupCb(appBeforeHib,&inParam,SLPMAN_HIBERNATE_STATE);
    slpManRegisterUsrdefinedRestoreCb(appAfterHib,NULL,SLPMAN_HIBERNATE_STATE);
    slpManRegisterUsrdefinedBackupCb(appBeforeSlp1,NULL,SLPMAN_SLEEP1_STATE);
    slpManRegisterUsrdefinedRestoreCb(appAfterSlp1,NULL,SLPMAN_SLEEP1_STATE);
    slpManRegisterUsrdefinedBackupCb(appBeforeSlp2,NULL,SLPMAN_SLEEP2_STATE);
    slpManRegisterUsrdefinedRestoreCb(appAfterSlp2,NULL,SLPMAN_SLEEP2_STATE);

    slpManSlpState_t slpstate = slpManGetLastSlpState();

    #ifdef USING_PRINTF
            printf("slpstate:%d \n",slpstate);
    #endif
    Wakeup_source =  slpManGetWakeupSrc();//获取唤醒源
    #ifdef USING_PRINTF
            printf("Wakeup_source:%d \n",Wakeup_source);
    #endif
    if (Wakeup_source==0)
    {
        sleep_time_flag = Wakeup_Work_time;
    }
    else if (Wakeup_source==1)
    {
        sleep_time_flag = Wakeup_Work_time;
    }
    else
    {
        sleep_time_flag = Chrgend_Work_time;
    }
    if((slpstate == SLP_SLP2_STATE) || (slpstate == SLP_HIB_STATE))
    {
        PROC_MAIN_STATE_SWITCH(PROCESS_STATE_WORK);
    }
    else
    {
        PROC_MAIN_STATE_SWITCH(PROCESS_STATE_WORK);
    }
    while (true)
    {
        switch(gProcess_Main_Task)
        {
            case PROCESS_STATE_IDLE:
            {
                // 暂时不区分唤醒
                PROC_MAIN_STATE_SWITCH(PROCESS_STATE_WORK);
                break;
            }
            case PROCESS_STATE_WORK:
            {
                osDelay(10/portTICK_PERIOD_MS);
                Can_index++;
                Uart_index++;
                Tcp_index++;
                sleep_index++;
                if (Tcp_index >=100)//Tcp 1s 调用一次
                {
                    #ifdef USING_PRINTF
                        printf("[%d]_sleep count \r\n",sleep_index);
                    #endif
                    Tcp_index = 0;
                    PROC_TCP_STATE_SWITCH(PROCESS_TCP_STATE_LINK);
                }
                if (sleep_index >=sleep_time_flag*100)
                {
                    PROC_MAIN_STATE_SWITCH(PROCESS_STATE_SLEEP);
                    sleep_index = 0;
                }
                break;
            }
            case PROCESS_STATE_SLEEP:
            {
                osDelay(10000);
                slpManSlpState_t State;
                uint8_t cnt;
                if(slpManCheckVoteState(MainSlpHandler, &State, &cnt)==RET_TRUE)
                {
                    #ifdef USING_PRINTF
                        printf("[%d]We Can Check Vote Main State, state=%d, cnt=%d\r\n",__LINE__,State,cnt);
                    #endif						
                }
                slpManPlatVoteForceEnableSleep(MainSlpHandler, SLP_SLP2_STATE); //增加强制投票
                if(slpManCheckVoteState(MainSlpHandler, &State, &cnt)==RET_TRUE)
                {
                    #ifdef USING_PRINTF
                        printf("[%d]We Can Check Vote Main State Again, state=%d, cnt=%d\r\n",__LINE__,State,cnt);
                    #endif					
                }
                #ifdef USING_PRINTF
                            printf("[%d]Waiting sleep\r\n",__LINE__);
                #endif
                FaultDisplay(LED_TURN_ON);
                slpManSlpState_t slpstate = slpManPlatGetSlpState();
                #ifdef USING_PRINTF
                    printf("which slpstate can go now :%d \n",slpstate);
                #endif
                slpManDeepSlpTimerStart(deepslpTimerID, Sleep_Time);
                while(1)
                {
                    if(!slpManDeepSlpTimerIsRunning(deepslpTimerID))
                    {
                        slpManDeepSlpTimerDel(deepslpTimerID);
                    }
                    slpManDeepSlpTimerStart(deepslpTimerID, Sleep_Time*1000);
                    osDelay(60000/portTICK_PERIOD_MS);
                }
                break;
            }
        }

    }
    

}
static INT32 socketRegisterPSUrcCallback(urcID_t eventID, void *param, UINT32 paramLen)
{
    CmiSimImsiStr *imsi = NULL;
    CmiPsCeregInd *cereg = NULL;

    UINT8 rssi = 0, index = 0;
    NmAtiNetifInfo *netif = NULL;

    switch(eventID)
    {
        case NB_URC_ID_SIM_READY:
        {
            imsi = (CmiSimImsiStr *)param;
            memcpy(gImsi, imsi->contents, imsi->length);
            #ifdef USING_PRINTF
                printf("SIM ready(imsi=%s)\n",(UINT8 *)imsi->contents);
            #endif
            break;
        }
        case NB_URC_ID_MM_SIGQ:
        {
            rssi = *(UINT8 *)param;
            #ifdef USING_PRINTF
                printf("RSSI signal=%d\n",rssi);
            #endif
            ECOMM_TRACE(UNILOG_PLA_APP, socketRegisterPSUrcCallback_1, P_INFO, 1, "RSSI signal=%d", rssi);
            break;
        }
        case NB_URC_ID_PS_BEARER_ACTED:
        {
            #ifdef USING_PRINTF
                printf("Default bearer activated\n");
            #endif
            break;
        }
        case NB_URC_ID_PS_BEARER_DEACTED:
        {
            #ifdef USING_PRINTF
                printf("Default bearer Deactivated\n");
            #endif
            break;
        }
        case NB_URC_ID_PS_CEREG_CHANGED:
        {
            cereg = (CmiPsCeregInd *)param;
            gCellID = cereg->celId;
            #ifdef USING_PRINTF
                printf("URCCallBack:CEREG changed act:%d celId:%d locPresent:%d tac:%d\n", cereg->act, cereg->celId, cereg->locPresent, cereg->tac);
            #endif
            break;
        }
        case NB_URC_ID_PS_NETINFO:
        {
            netif = (NmAtiNetifInfo *)param;
            if (netif->netStatus == NM_NETIF_ACTIVATED)
                //sendQueueMsg(QMSG_ID_NW_IP_READY, 0);
                Tcp_statuts = 1;
            break;
        }
    }
    return 0;
}
static void Tcp_Task(void* arg)
{
    CHAR   serverip[] = "120.26.68.165";
    CHAR  serverport[] = "14319";
    struct addrinfo hints, *server_res;
    memset( &hints, 0, sizeof( hints ) );
    hints.ai_socktype = SOCK_STREAM;
    hints.ai_protocol = IPPROTO_TCP;
    uint8_t* TcpSendBuffer=NULL;
    uint8_t Reconnect_Num = 0;
    int TcpsendID = -1;
    PROC_TCP_STATE_SWITCH(PROCESS_TCP_STATE_IDLE);
    while(true)
    {
        switch(gProcess_Tcp_Task)
        {
            case PROCESS_TCP_STATE_IDLE:
            {
                osDelay(100);
                break;
            }
            case PROCESS_TCP_STATE_LINK:
            {
                #ifdef USING_PRINTF
                    printf("TCP_statuts:%d\n",Tcp_statuts);
                #endif
                switch(Tcp_statuts)
                {
                    case 0://0代表网络为驻网前
                    {
                        #ifdef USING_PRINTF
                                printf("TCP Not Ready\n");
                        #endif
                        PROC_TCP_STATE_SWITCH(PROCESS_TCP_STATE_IDLE);
                        break;
                    }
                    case 1://1代表网络驻网
                    {
                        if (getaddrinfo( serverip, serverport , &hints, &server_res ) != 0 )
                        {
                            #ifdef USING_PRINTF
                                printf("TCP connect unresolved dns\n");
                            #endif
                        }
                        Tcp_statuts=2;
                        break;
                    }
                    case 2://2代表尝试建立连接
                    {
                        #ifdef USING_PRINTF
                            printf("Connecting...!%d\n",TcpconnectID);
                        #endif
                        sockfd = socket(AF_INET, SOCK_STREAM, 0);
                        if(sockfd<0)
                        {
                            #ifdef USING_PRINTF
                                printf("socket create error\n");
                            #endif
                            Tcp_statuts=1;
                        }
                        else
                        {
                            TcpconnectID = connect(sockfd, (struct sockaddr *) server_res->ai_addr, server_res->ai_addrlen);
                            if(TcpconnectID<0 && errno != EINPROGRESS)
                            {
                                #ifdef USING_PRINTF
                                    printf("Connect failed!%d,Reconnect:%d\n",TcpconnectID,Reconnect_Num);
                                #endif
                                // close(sockfd);
                                Tcp_statuts=2;
                                PROC_TCP_STATE_SWITCH(PROCESS_TCP_STATE_IDLE);
                                Reconnect_Num++;
                            }
                            else
                            {
                                Tcp_statuts=3;
                                Reconnect_Num = 0;
                            }
                            if(Reconnect_Num>=20)
                            {
                                appSetCFUN(0);
                                osDelay(10);
                                appSetCFUN(1);
                                PSInitEventCallbackTable();
                                Tcp_statuts=1;
                                Reconnect_Num = 0;
                            }
                        }
                        break;
                    }
                    case 3://3代表连接建立成功
                    {
                        PROC_TCP_STATE_SWITCH(PROCESS_TCP_STATE_WORK);
                        break;
                    }
                    case 4://4代表连接断开
                    {
                        Tcp_statuts=2;
                        break;
                    }
                }
                break;
            }
            case PROCESS_TCP_STATE_WORK:
            {
                TcpSendBuffer = (uint8_t *)malloc(3);
                *(TcpSendBuffer+0) = 0x23;
                *(TcpSendBuffer+1) = 0x23;
                *(TcpSendBuffer+2) = 0x02;
                TcpsendID = send(sockfd, TcpSendBuffer, 3, 0 );
                if (TcpsendID<0)
                {
                    closesocket(sockfd);
                    TcpconnectID = -1;
                    Tcp_statuts = 4;
                    PROC_TCP_STATE_SWITCH(PROCESS_TCP_STATE_LINK);
                }
                else
                {
                    PROC_TCP_STATE_SWITCH(PROCESS_TCP_STATE_IDLE);
                }
                break;
            }
            case PROCESS_TCP_STATE_SLEEP:
            {
                closesocket(sockfd);
                #ifdef USING_PRINTF
                    printf("TCP_STATE_SLEEP\n");
                #endif
                Tcp_Sleep_Flag = TRUE;
                appSetCFUN(0);
                while(1)
                {
                    osDelay(30000/portTICK_PERIOD_MS);
                }
                break;
            }
        }
    }
}
//Tcp线程初始化
void Tcp_Task_Init()
{
    osThreadAttr_t task_attr;
    registerPSEventCallback(NB_GROUP_ALL_MASK, socketRegisterPSUrcCallback);
    memset(&task_attr,0,sizeof(task_attr));
    memset(gProcess_Tcp_TaskStack, 0xA5, PROC_TCP_TASK_STACK_SIZE);
    task_attr.name = "Tcp_Task";
    task_attr.stack_mem = gProcess_Tcp_TaskStack;
    task_attr.stack_size = PROC_TCP_TASK_STACK_SIZE;
    task_attr.priority = osPriorityNormal;
    task_attr.cb_mem = &gProcess_Tcp_Task_t;
    task_attr.cb_size = sizeof(StaticTask_t);
    osThreadNew(Tcp_Task, NULL, &task_attr);

}
//主任务线程初始化
void Main_Task_Init()
{
    #ifndef USING_PRINTF
    if(BSP_GetPlatConfigItemValue(PLAT_CONFIG_ITEM_LOG_CONTROL) != 0)
    {
        HAL_UART_RecvFlowControl(false);
    }
    #endif
    //slpManDeepSlpTimerRegisterExpCb(slpManTimerCb);
    osThreadAttr_t task_attr;
    memset(&task_attr,0,sizeof(task_attr));
    memset(gProcess_Main_TaskStack, 0xA5, PROC_MAIN_TASK_STACK_SIZE);
    task_attr.name = "Main_Task";
    task_attr.stack_mem = gProcess_Main_TaskStack;
    task_attr.stack_size = PROC_MAIN_TASK_STACK_SIZE;
    task_attr.priority = osPriorityNormal;
    task_attr.cb_mem = &gProcess_Main_Task_t;
    task_attr.cb_size = sizeof(StaticTask_t);
    osThreadNew(Main_Task, NULL, &task_attr);
}
void appInit(void *arg)
{
    Main_Task_Init();
    Tcp_Task_Init();
}
//主函数入口
void main_entry(void) 
{
    BSP_CommonInit();
    osKernelInitialize();
    registerAppEntry(appInit, NULL);
    if (osKernelGetState() == osKernelReady)
    {
        osKernelStart();
    }
    while(1);
}
